var BookmarksTreeClick2Tab = 
{
    init : function ()
    {
        bookmarksViewClick2Tab = document.getElementById("bookmarks-view");
        bookmarksViewClick2Tab.__openItemClick = bookmarksViewClick2Tab.openItemClick;
        bookmarksViewClick2Tab.openItemClick = this.openItemClick;
    },

    deinit : function()
    {
        bookmarksViewClick2Tab.openItemClick = bookmarksViewClick2Tab.__openItemClick;
    },

    openItemClick : function (aEvent, aClickCount)
    {
        if (aEvent.button == 2 || aEvent.originalTarget.localName != "treechildren")
            return;
        if (aClickCount != this.clickCount && aEvent.button != 1)
            return;

        var row = {};
        var col = {};
        var obj = {};
        this.treeBoxObject.getCellAt(aEvent.clientX, aEvent.clientY, row, col, obj);
        row = row.value;

        if (row == -1 || obj.value == "twisty")
            return;
        var modifKey = aEvent.shiftKey || aEvent.ctrlKey || aEvent.altKey || 
                       aEvent.metaKey  || aEvent.button == 1;
        if (this.clickCount == 2 && !modifKey &&
            this.treeBoxObject.view.isContainer(row))
            return;

        if (this.clickCount == 2 && modifKey) {
            this.treeBoxObject.selection.select(row);
            this._selection = this.getTreeSelection();
        }
        var selection = this._selection;

        if (selection.isContainer[0]) {
            if (this.clickCount == 1 && !modifKey) {
                this.treeBoxObject.view.toggleOpenState(row);
                //XXXpch: broken since we have single IDs
                //if (selection.protocol[0] != "file")
                return;
            }
        }
        // Code changed to open bookmark item in new tab when the current tab isn't blank
        // By NetOne on 2004/11/17
        var browserTarget = whereToOpenLinkClick2Tab(aEvent, 
                                prefStringClick2TabBookmark, selection, this.db);

        BookmarksCommand.openBookmark(selection, browserTarget, this.db);
        // give focus back to this; openBookmark/openLocation steals it and gives it
        // to the browser content.  This is to make things like cut/copy/etc. behave sanely
        // in the bookmarks sidebar.
        this.focus();
    }
};
